
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Exam_questionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const exam_questions = await db.exam_questions.create(
            {
                id: data.id || undefined,
        
        question_type: data.question_type
        ||
        null
            ,
            
        question_text: data.question_text
        ||
        null
            ,
            
        points: data.points
        ||
        null
            ,
            
        order_number: data.order_number
        ||
        null
            ,
            
        active: data.active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await exam_questions.setExam( data.exam || null, {
            transaction,
        });
        
        await exam_questions.setSchools( data.schools || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.exam_questions.getTableName(),
                belongsToColumn: 'question_media',
                belongsToId: exam_questions.id,
            },
            data.question_media,
            options,
        );
        

        return exam_questions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const exam_questionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                question_type: item.question_type
            ||
            null
            ,
            
                question_text: item.question_text
            ||
            null
            ,
            
                points: item.points
            ||
            null
            ,
            
                order_number: item.order_number
            ||
            null
            ,
            
                active: item.active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const exam_questions = await db.exam_questions.bulkCreate(exam_questionsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < exam_questions.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.exam_questions.getTableName(),
                    belongsToColumn: 'question_media',
                    belongsToId: exam_questions[i].id,
                },
                data[i].question_media,
                options,
            );
        }
        

        return exam_questions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const exam_questions = await db.exam_questions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.question_type !== undefined) updatePayload.question_type = data.question_type;
        
        
        if (data.question_text !== undefined) updatePayload.question_text = data.question_text;
        
        
        if (data.points !== undefined) updatePayload.points = data.points;
        
        
        if (data.order_number !== undefined) updatePayload.order_number = data.order_number;
        
        
        if (data.active !== undefined) updatePayload.active = data.active;
        
        
        updatePayload.updatedById = currentUser.id;

        await exam_questions.update(updatePayload, {transaction});

        
        
        if (data.exam !== undefined) {
            await exam_questions.setExam(
              
              data.exam,
              
              { transaction }
            );
        }
        
        if (data.schools !== undefined) {
            await exam_questions.setSchools(
              
              data.schools,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.exam_questions.getTableName(),
                belongsToColumn: 'question_media',
                belongsToId: exam_questions.id,
            },
            data.question_media,
            options,
        );
        

        return exam_questions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const exam_questions = await db.exam_questions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of exam_questions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of exam_questions) {
                await record.destroy({transaction});
            }
        });


        return exam_questions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const exam_questions = await db.exam_questions.findByPk(id, options);

        await exam_questions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await exam_questions.destroy({
            transaction
        });

        return exam_questions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const exam_questions = await db.exam_questions.findOne(
            { where },
            { transaction },
        );

        if (!exam_questions) {
            return exam_questions;
        }

        const output = exam_questions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.exam_question_choices_exam_question = await exam_questions.getExam_question_choices_exam_question({
            transaction
        });
        
        
        
        output.exam_answers_exam_question = await exam_questions.getExam_answers_exam_question({
            transaction
        });
        
        
        
        
        
        
        
        output.exam = await exam_questions.getExam({
            transaction
        });
        
        
        output.question_media = await exam_questions.getQuestion_media({
            transaction
        });
        
        
        output.schools = await exam_questions.getSchools({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userSchools = (user && user.schools?.id) || null;
        

        
        if (userSchools) {
            if (options?.currentUser?.schoolsId) {
                where.schoolsId = options.currentUser.schoolsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.exams,
        as: 'exam',
        
        where: filter.exam ? {
          [Op.or]: [
            { id: { [Op.in]: filter.exam.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.exam.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.schools,
        as: 'schools',
        
      },



      {
        model: db.file,
        as: 'question_media',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.question_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'exam_questions',
                        'question_text',
                        filter.question_text,
                    ),
                };
            }
            

            
            

            
            if (filter.pointsRange) {
                const [start, end] = filter.pointsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    points: {
                    ...where.points,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    points: {
                    ...where.points,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.order_numberRange) {
                const [start, end] = filter.order_numberRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    order_number: {
                    ...where.order_number,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    order_number: {
                    ...where.order_number,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.question_type) {
                where = {
                    ...where,
                question_type: filter.question_type,
            };
            }
            
            if (filter.active) {
                where = {
                    ...where,
                active: filter.active,
            };
            }
            


      

      
      if (filter.schools) {
        const listItems = filter.schools.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          schoolsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.schoolsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.exam_questions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'exam_questions',
                        'question_text',
                        query,
                    ),
                ],
            };
        }

        const records = await db.exam_questions.findAll({
            attributes: [ 'id', 'question_text' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['question_text', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.question_text,
        }));
    }

    
};

